#ifndef _Promise_h
#define _Promise_h
#include <mutex>
#include <future> // 'std::promise'...
#include <list>
#include <string>

class Image {
	static std::list<std::launch> _Start; // Benchmarking only...
	static std::list<std::launch> _End; // Benchmarking only...
	static std::mutex _Mutex; // Benchmarking only...

	const std::string _file_name;
public:
	Image(std::string&&);
	std::string process(const std::launch&) noexcept(false);
};

class Promise {
	std::promise<std::string> _p;
public:
	Promise();
	void request_Resource(std::string&&);
	std::string get_Resource();
};

#endif